
Redmine - Defect #30455

Adding an issue note via email fails due to NoMethodError

2019-01-17 10:55 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Email receiving Estimated time: 0.00 hour

Target version: 4.0.1   

Resolution: Fixed Affected version: 4.0.0

Description

After upgrading my production Redmine to 4.0.0, I encountered a critical problem that I cannot add issue notes by replying emails.

On investigation, it turned out that NoMethodError that is raised at source:tags/4.0.0/app/models/mail_handler.rb#L240 causes the

problem.

     # ignore CLI-supplied defaults for new issues

     handler_options[:issue].clear

 The code expects that the class of handler_options[:issue] is Hash, however, it is actually ActionController::Parameters. Since the

class does not have a "clear" method, the code raises exception and Redmine fails to add the email to the issue note.

The error cannot be detected by running the unit test because the class of handler_options[:issue] is not

ActionController::Parameters but Hash in a test environment.

The following is a workaround for this issue.

Index: app/models/mail_handler.rb

===================================================================

--- app/models/mail_handler.rb    (revision 17805)

+++ app/models/mail_handler.rb    (working copy)

@@ -237,7 +237,7 @@

     end

     # ignore CLI-supplied defaults for new issues

-    handler_options[:issue].clear

+    handler_options[:issue] = {}

     journal = issue.init_journal(user)

     if from_journal && from_journal.private_notes?

Associated revisions

Revision 17817 - 2019-01-19 11:59 - Jean-Philippe Lang

Adding an issue note via email fails due to NoMethodError (#30455).

Patch by Go MAEDA.

Revision 17818 - 2019-01-19 12:00 - Jean-Philippe Lang

Merged r17817 to 4.0-stable (#30455).

History

#1 - 2019-01-17 10:58 - Go MAEDA

- Target version set to 4.0.1

This is a serious issue that must be fixed asap.

#2 - 2019-01-17 12:50 - Go MAEDA

- File 30455-fix.diff added
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/4.0.0/app/models/mail_handler.rb#L240


Attaching a patch with a test.

#3 - 2019-01-17 13:31 - Go MAEDA

- File 30455-fix-v2.diff added

Slightly improved the test.

#4 - 2019-01-19 12:00 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.

Files

30455-fix.diff 1.22 KB 2019-01-17 Go MAEDA

30455-fix-v2.diff 1.28 KB 2019-01-17 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

